%define anolis_release  .1
Name:			rasdaemon
Version:		0.8.3
Release:		1%{anolis_release}%{?dist}
Summary:		Utility to receive RAS error tracings
License:		GPL-2.0-only
URL:			http://git.infradead.org/users/mchehab/rasdaemon.git
Source0:		http://www.infradead.org/~mchehab/rasdaemon/%{name}-%{version}.tar.bz2
Patch1001: 1001-config-add-syslog-ng-and-logrotate-config.patch
Patch1002: 1002-config-add-rsyslog-config.patch
Patch1003: 1003-rasdaemon-trace-SIGBUS-event-for-hardware-error.patch
Patch1004: 1004-rasdaemon-align-event-name-in-log.patch
Patch1005: 1005-rasdaemon-skip-doesn-t-exist-event.patch
Patch1006: 1006-rasdaemon-support-memory-corrected-error-statistics.patch
Patch1007: 1007-rasdaemon-introduce-poison-page-statistics.patch
Patch1008: 1008-rasdaemon-erst-decode-panic-mce-through-erst.patch
Patch1009: 1009-aer-print-pci-device-name-and-vendor-device-id.patch
Patch1010: 1010-rasdaemon-introduce-EDPC-config-in-rasdaemon.patch
Patch1011: 1011-rasdaemon-support-nvgpu-event.patch
Patch1012: 1012-rasdaemon-enhance-rasdaemon-event-trigger.patch
Patch1013: 1013-rasdaemon-add-event-level-for-event-record.patch
Patch1014: 1014-anolis-syslog-add-rasdaemon.ext.patch
Patch1015: 1015-rasdaemon-add-page-offline-trigger.patch
Patch1016: 1016-anolis-compta-rasdaemon-notices.patch
Patch1017: 1017-anolis-rasdaemon-add-rasdaemon-json-exporter.patch
Patch1018: 1018-anolis-rasdaemon-kmsg_monitor-introduce-kmsg_monitor.patch
Patch1019: 1019-rasdaemon-erst-add-erst-mce-erst-dmesg.patch
Patch1020: 1020-anolis-rasdaemon-add-amdgpu-ras-error-monitor.patch
Patch1021: 1021-anolis-config-disable-page-offline-defalut.patch
Patch1022: 1022-anolis-disable-block-and-dev-error-default.patch
Patch1023: 1023-anolis-add-nvml-in-tree.patch
Patch1024: 1024-anolis-do-not-print-teq-error.patch
Patch1025: 1025-anolis-add-init.sh-for-different-user.patch
Patch1026: 1026-anolis-fix-systemd-config.patch
Patch1027: 1027-anolis-add-nvgpu-driver.patch
Patch1028: 1028-anolis-add-trigger-for-nvgpu-event.patch
Patch1029: 1029-anolis-add-nvgpu-reset-trigger.patch
Patch1030: 1030-rasdaemon-split-report-function.patch
Patch1031: 1030-rasdaemon-support-BERT-decode.patch
Patch1032: 1031-config-update-config.patch
Patch1033: 1032-test-add-testsuite.patch

ExcludeArch:		s390 s390x
BuildRequires:		make
BuildRequires:		gcc
BuildRequires:		gettext-devel
BuildRequires:		perl-generators
BuildRequires:		sqlite-devel
BuildRequires:		systemd
BuildRequires:		autoconf
BuildRequires:		automake
BuildRequires:		libtool
BuildRequires:		libtraceevent-devel
BuildRequires:		pciutils-devel
BuildRequires:		zlib-devel
BuildRequires:		python3
BuildRequires:		rasdaemon-open-gpu-kernel-modules
Provides:		bundled(kernel-event-lib)
Requires:		hwdata
Requires:		perl-DBD-SQLite
Requires:		libtraceevent
Requires:		pciutils
Requires:		zlib
%ifarch %{ix86} x86_64
Requires:		dmidecode
%endif

Requires(post):		systemd
Requires(preun):	systemd
Requires(postun):	systemd

%description
%{name} is a RAS (Reliability, Availability and Serviceability) logging tool.
It currently records memory errors, using the EDAC tracing events.
EDAC is drivers in the Linux kernel that handle detection of ECC errors
from memory controllers for most chipsets on i386 and x86_64 architectures.
EDAC drivers for other architectures like arm also exists.
This userspace component consists of an init script which makes sure
EDAC drivers and DIMM labels are loaded at system startup, as well as
an utility for reporting current error counts from the EDAC sysfs files.

%prep
%setup -q
tar -xf /usr/share/rasdaemon-open-gpu-kernel-modules/*.tar.gz
mv open-gpu-kernel-modules-* open-gpu-kernel-modules
%patch1001 -p1
%patch1002 -p1
%patch1003 -p1
%patch1004 -p1
%patch1005 -p1
%patch1006 -p1
%patch1007 -p1
%patch1008 -p1
%patch1009 -p1
%patch1010 -p1
%patch1011 -p1
%patch1012 -p1
%patch1013 -p1
%patch1014 -p1
%patch1015 -p1
%patch1016 -p1
%patch1017 -p1
%patch1018 -p1
%patch1019 -p1
%patch1020 -p1
%patch1021 -p1
%patch1022 -p1
%patch1023 -p1
%patch1024 -p1
%patch1025 -p1
%patch1026 -p1
%patch1027 -p1
%patch1028 -p1
%patch1029 -p1
%patch1030 -p1
%patch1031 -p1
%patch1032 -p1
%patch1033 -p1

autoreconf -vfi

%build
%ifarch loongarch64
%configure --enable-sqlite3 --enable-aer --enable-non-standard \
           --enable-devlink --enable-diskerror \
           --enable-memory-failure --enable-abrt-report --enable-cpu-fault-isolation \
           --enable-cxl --enable-json-report --enable-memory-ce-pfa --enable-memory-row-ce-pfa \
           --enable-signal --enable-erst --enable-kmsg-monitor \
           --with-sysconfdefdir=%{_sysconfdir}/sysconfig
%else
%configure --enable-all --with-sysconfdefdir=%{_sysconfdir}/sysconfig
%endif
make %{?_smp_mflags}

%install
make install DESTDIR=%{buildroot}
install -D -p -m 0644 misc/%{name}.service %{buildroot}%{_unitdir}/%{name}.service
install -D -p -m 0644 misc/ras-mc-ctl.service %{buildroot}%{_unitdir}/ras-mc-ctl.service
install -D -p -m 0655 misc/%{name}.env %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -D -p -m 0655 misc/%{name}.syslog-ng %{buildroot}/usr/share/%{name}/%{name}.syslog-ng
install -D -p -m 0655 misc/%{name}.logrotate %{buildroot}/usr/share/%{name}/%{name}.logrotate
install -D -p -m 0655 misc/%{name}.rsyslog %{buildroot}/usr/share/%{name}/%{name}.rsyslog
install -D -p -m 0655 misc/%{name}.rsyslog-ext %{buildroot}/usr/share/%{name}/%{name}.rsyslog-ext
install -D -p -m 0655 misc/%{name}.syslog-ng-ext %{buildroot}/usr/share/%{name}/%{name}.syslog-ng-ext
install -d %{buildroot}%{_sysconfdir}/rasdaemon_notices/
install -D -p -m 0755 misc/notices/* %{buildroot}%{_sysconfdir}/rasdaemon_notices/
install -D -p -m 0755 contrib/%{name}.init %{buildroot}/usr/share/%{name}/%{name}.init
rm INSTALL %{buildroot}/usr/include/*.h

%files
%doc AUTHORS ChangeLog COPYING TODO
%{_sbindir}/%{name}
%{_sbindir}/ras-mc-ctl
%{_mandir}/*/*
%{_unitdir}/*.service
%{_sysconfdir}/ras/dimm_labels.d
%{_sysconfdir}/ras/*/*
%{_sysconfdir}/sysconfig/%{name}
/usr/share/%{name}/%{name}.syslog-ng
/usr/share/%{name}/%{name}.logrotate
/usr/share/%{name}/%{name}.rsyslog
/usr/share/%{name}/%{name}.syslog-ng-ext
/usr/share/%{name}/%{name}.rsyslog-ext
/usr/share/%{name}/%{name}.init
%{_sysconfdir}/rasdaemon_notices/*

%post
if systemctl is-active --quiet syslog-ng.service; then
    echo "Syslog service is enabled and running, create config file and restart it";
    rm -rf %{_sysconfdir}/syslog-ng/conf.d/%{name}.conf;
    ln -s /usr/share/%{name}/%{name}.syslog-ng %{_sysconfdir}/syslog-ng/conf.d/%{name}.conf;
    rm -rf %{_sysconfdir}/syslog-ng/conf.d/%{name}-ext.conf;
    ln -s /usr/share/%{name}/%{name}.syslog-ng-ext %{_sysconfdir}/syslog-ng/conf.d/%{name}-ext.conf;
    systemctl restart syslog-ng.service;
fi
if systemctl is-active --quiet rsyslog.service; then
    echo "Rsyslog service is enabled and running, create config file and restart it";
    rm -rf %{_sysconfdir}/rsyslog.d/%{name}.conf;
    ln -s /usr/share/%{name}/%{name}.rsyslog %{_sysconfdir}/rsyslog.d/%{name}.conf;
    rm -rf %{_sysconfdir}/rsyslog.d/%{name}-ext.conf;
    ln -s /usr/share/%{name}/%{name}.rsyslog-ext %{_sysconfdir}/rsyslog.d/%{name}-ext.conf;
    systemctl restart rsyslog.service;
fi
if [ -d "%{_sysconfdir}/logrotate.d" ]; then
    rm -rf %{_sysconfdir}/logrotate.d/%{name};
    ln -s /usr/share/%{name}/%{name}.logrotate %{_sysconfdir}/logrotate.d/%{name};
fi
if ! systemctl is-enabled --quiet %{name}.service; then
    echo "Rasdaemon service is not enabled, enable it";
    systemctl enable %{name}.service;
fi
echo "Rasdaemon install for ${RASDAEMON_TARGET}";
/usr/share/%{name}/%{name}.init ${RASDAEMON_TARGET}

systemctl daemon-reload
systemctl restart %{name}.service

%preun
if [ $1 -eq 0 ] ; then
	systemctl stop %{name}.service
	systemctl disable %{name}.service
fi

%postun
if systemctl is-active --quiet syslog-ng.service; then
    echo "Syslog-ng service is enabled and running, delete config file and restart it";
    rm -rf %{_sysconfdir}/syslog-ng/conf.d/%{name}.conf;
    rm -rf %{_sysconfdir}/syslog-ng/conf.d/%{name}-ext.conf;
    systemctl restart syslog-ng.service;
fi
if systemctl is-active --quiet rsyslog.service; then
    echo "Rsyslog service is enabled and running, delete config file and restart it";
    rm -rf %{_sysconfdir}/rsyslog.d/%{name}.conf;
    rm -rf %{_sysconfdir}/rsyslog.d/%{name}-ext.conf;
    systemctl restart rsyslog.service;
fi
if [ -d "%{_sysconfdir}/logrotate.d" ]; then
    rm -rf %{_sysconfdir}/logrotate.d/%{name};
fi

%changelog
* Tue Jul 15 2025 Ruidong Tian <tianruidong@linux.alibaba.com> - 0.8.3-1.1
- support bert decode
- update rasdaemon config

* Thu Mar 20 2025 wangzhe <wanglan.wz@alibaba-inc.com> - 0.8.3-1.0.1
- update to 0.8.3
- support mc event stat
- support poison stat
- support log level
- support nvgpu event 

* Mon Mar 10 2025 Ruidong Tian <tianruidong@linux.alibaba.com> - 0.6.7-16.0.2
- fix signal bug
- refactor kmsg storm migration

* Wed Dec 25 2024 Ruidong Tian <tianruidong@linux.alibaba.com> - 0.6.7-16.0.1
- add erst, kmsg, amdgpu_ras

* Thu Dec 05 2024 Bixuan Cui <cuibixuan@linux.alibaba.com> - 0.6.7-15.0.1
- rasdaemon: add notification support when page goes offline for Memory Corrected Error
- rasdaemon: add decoder to decode yitian ns error (tianruidong@linux.alibaba.com)
- rasdaemon: add mce and mc trigger (tianruidong@linux.alibaba.com)
- rasdaemon: AMD mce record just print one line (tianruidong@linux.alibaba.com)

* Thu Jul 18 2024 Aristeu Rozanski <aris@redhat.com> 0.6.7-14
- rasdaemon: mce-amd-smca: Optimizing decoding of MCA_CTL_SMU bits [RHEL-48819]

* Fri Jun 28 2024 Aristeu Rozanski <aris@redhat.com> 0.6.7-13
- rasdaemon: Add error decoding for MCA_CTL_SMU extended bits [RHEL-35718]

* Thu Jun 20 2024 Aristeu Rozanski <aris@redhat.com> 0.6.7-12
- mce-amd-smca: update smca_hwid to use smca_bank_types [RHEL-24170]

* Wed May 08 2024 Aristeu Rozanski <aris@redhat.com> 0.6.7-11
- Fix excessive block messages [RHEL-8708]

* Wed Jan 10 2024 Aristeu Rozanski <aris@redhat.com> 0.6.7-10
- Update License string to use SPDX [RHELMISC-1262]

* Thu Oct 26 2023 Aristeu Rozanski <aris@redhat.com> 0.6.7-9
- Update SMCA support for AMD processors [RHEL-11092]

* Tue May 03 2022 Aristeu Rozanski <aris@redhat.com> 0.6.7-8
- Update ras-mc-ctl manpage to match current options [2079132]

* Mon May 02 2022 Aristeu Rozanski <aris@redhat.com> 0.6.7-7
- Fix issue printing memory module sizes [2080596]

* Thu Mar 31 2022 Aristeu Rozanski <aris@redhat.com> 0.6.7-6
- Merging 2065729 fixes into 9.1 branch [2067499]

* Thu Mar 24 2022 Aristeu Rozanski <aris@redhat.com> 0.6.7-5
- Trying to guess what's going on on the testing side [2065729]

* Thu Mar 24 2022 Aristeu Rozanski <aris@redhat.com> 0.6.7-4
- Adding simple test to stop being gated [2065729]

* Thu Mar 24 2022 Aristeu Rozanski <aris@redhat.com> 0.6.7-3
- Adding gating.yaml [2065729]

* Fri Mar 18 2022 Aristeu Rozanski <aris@redhat.com> 0.6.7-2
- Adding missing rasdaemon environment configuration to /etc/sysconfig/rasdaemon [2065729]

* Tue Feb 08 2022 Aristeu Rozanski <aris@redhat.com> 0.6.7-1
- Bumped to 0.6.7
- Backported patches that sit on top of 0.6.7 without being released
  Related: rhbz#2052190

* Tue Aug 10 2021 Mohan Boddu <mboddu@redhat.com> - 0.6.4-6
- Rebuilt for IMA sigs, glibc 2.34, aarch64 flags
  Related: rhbz#1991688

* Fri Apr 16 2021 Mohan Boddu <mboddu@redhat.com> - 0.6.4-5
- Rebuilt for RHEL 9 BETA on Apr 15th 2021. Related: rhbz#1947937

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.4-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild


* Thu Oct 10 2019 Mauro Carvalho Chehab <mchehab+samsung@kernel.org>  0.6.4-1
- Bump to version 0.6.4 with some DB changes for hip08 and some fixes

* Fri Aug 23 2019 Mauro Carvalho Chehab <mchehab+samsung@kernel.org>  0.6.3-1
- Bump to version 0.6.3 with new ARM events, plus disk I/O and netlink support

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Tue Aug 14 2018 Mauro Carvalho Chehab <mchehab+samsung@kernel.org>  0.6.2-1
- Bump to version 0.6.2 with improvements for PCIe AER parsing and at ras-mc-ctl tool

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Apr 25 2018 Mauro Carvalho Chehab <mchehab+samsung@kernel.org>  0.6.1-1
- Bump to version 0.6.1 adding support for Skylake Xeon MSCOD, a bug fix and some new DELL labels

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sat Oct 14 2017 Mauro Carvalho Chehab <mchehab@osg.samsung.com>  0.6.0-1
- Bump to version 0.6.0 adding support for Arm and Hisilicon events and update Dell Skylate labels

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.8-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.8-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.8-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Apr 15 2016 Mauro Carvalho Chehab <mchehab@osg.samsung.com> 0.5.8-3
- Add a virtual provide, per BZ#104132

* Fri Apr 15 2016 Mauro Carvalho Chehab <mchehab@osg.samsung.com> 0.5.8-2
- Bump to version 0.5.8 with support for Broadwell EP/EX MSCOD/DE MSCOD

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.6-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jul 03 2015 Mauro Carvalho Chehab <mchehab@osg.samsung.com> 0.5.6-1
- Bump to version 0.5.6 with support for LMCE and some fixes

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Jun 03 2015 Mauro Carvalho Chehab <mchehab@osg.samsung.com> 0.5.5-1
- Bump to version 0.5.5 with support for newer Intel platforms & some fixes

* Tue Sep 16 2014 Peter Robinson <pbrobinson@fedoraproject.org> 0.5.4-3
- aarch64/ppc64 have edac capabilities
- spec cleanups
- No need to run autoreconf

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Fri Aug 15 2014 Mauro Carvalho Chehab <m.chehab@samsung.com> 0.5.4-1
- Bump to version 0.5.4 with some fixes, mainly for amd64

* Sun Aug 10 2014 Mauro Carvalho Chehab <m.chehab@samsung.com> 0.5.3-1
- Bump to version 0.5.3 and enable ABRT and ExtLog

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Apr 03 2014 Mauro Carvalho Chehab <m.chehab@samsung.com> 0.5.2-1
- fix and enable ABRT report support

* Fri Mar 28 2014 Mauro Carvalho Chehab <m.chehab@samsung.com> 0.5.1-1
- Do some fixes at the service files and add some documentation for --record

* Sun Feb 16 2014  Mauro Carvalho Chehab <m.chehab@samsung.com> 0.5.0-1
- Add experimental ABRT support

* Tue Sep 10 2013 Mauro Carvalho Chehab <m.chehab@samsung.com> 0.4.2-1
- Fix ras-mc-ctl layout filling

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jul 17 2013 Petr Pisar <ppisar@redhat.com> - 0.4.1-4
- Perl 5.18 rebuild

* Sun Jun  2 2013 Peter Robinson <pbrobinson@fedoraproject.org> 0.4.1-3
- ARM has EDMA drivers (currently supported in Calxeda highbank)

* Wed May 29 2013 Mauro Carvalho Chehab <mchehab@redhat.com> 0.4.1-2
- Fix the name of perl-DBD-SQLite package

* Wed May 29 2013 Mauro Carvalho Chehab <mchehab@redhat.com> 0.4.1-1
- Updated to version 0.4.1 with contains some bug fixes

* Tue May 28 2013 Mauro Carvalho Chehab <mchehab@redhat.com> 0.4.0-1
- Updated to version 0.4.0 and added support for mce, aer and sqlite3 storage

* Mon May 20 2013 Mauro Carvalho Chehab <mchehab@redhat.com> 0.3.0-1
- Package created

